
/*************************************************************************

  APU R 2.0

  bigfloatpt.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#include "bigfloatpt.h"

const char* BigFloat::Class_name = "BigFloat";

BigFloat
operator + (const BigFloat& a, const BigFloat&b) {
  BigFloat result = BigFloat(*((bigfloat*)a.frep) + *((bigfloat*)b.frep));
  return(result);
}

BigFloat
operator - (const BigFloat& a, const BigFloat&b) {
  BigFloat result = BigFloat(*((bigfloat*)a.frep) - *((bigfloat*)b.frep));
  return(result);
}

BigFloat
operator - (const BigFloat& a) {
  BigFloat result = BigFloat( - (*((bigfloat*)a.frep)));
  return(result);
}

BigFloat
operator * (const BigFloat& a, const BigFloat&b) {
  BigFloat result = BigFloat(*((bigfloat*)a.frep) * *((bigfloat*)b.frep));
  return(result);
}

BigFloat
operator / (const BigFloat& a, const BigFloat&b) {
  BigFloat result = BigFloat(*((bigfloat*)a.frep) / *((bigfloat*)b.frep));
  return(result);
}

bool
operator == (const BigFloat& a, const BigFloat&b) {
  return(*((bigfloat*)a.frep) == *((bigfloat*)b.frep));
}

bool
operator != (const BigFloat& a, const BigFloat&b) {
  return(*((bigfloat*)a.frep) != *((bigfloat*)b.frep));
}

bool
operator < (const BigFloat& a, const BigFloat&b) {
  return(*((bigfloat*)a.frep) < *((bigfloat*)b.frep));
}

bool
operator <= (const BigFloat& a, const BigFloat&b) {
  return(*((bigfloat*)a.frep) <= *((bigfloat*)b.frep));
}

bool
operator > (const BigFloat& a, const BigFloat&b) {
  return(*((bigfloat*)a.frep) > *((bigfloat*)b.frep));
}

bool
operator >= (const BigFloat& a, const BigFloat&b) {
  return(*((bigfloat*)a.frep) >= *((bigfloat*)b.frep));
}

bool 
is_zero(const BigFloat& a) {
  cout << "is_zero(BigFloat) not implemented \n"; 
  return false; 
  // return(isZero(*((bigfloat*)a.frep)));
}

int 
sign (const BigFloat& a) {
  return((int)(sign(*((bigfloat*)a.frep))));
}
