
/*************************************************************************

  APU R 2.0

  bigrat_smallint.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "smallint.h"
#include "bigrat.h"
#include "bigrat_smallint.h"

BigRat 
operator+ (const SmallInt& a, const BigRat& b) 
{
  BigRat result = BigRat(normalize(rational(a.i_value()) + b.rational_of()));
  return(result);
}

BigRat 
operator+ (const BigRat& a, const SmallInt& b) 
{
  BigRat result = BigRat(normalize(rational(b.i_value()) + a.rational_of()));
  return(result);
}

BigRat 
operator- (const SmallInt& a, const BigRat& b) 
{
  BigRat result = BigRat(normalize(rational(a.i_value()) - b.rational_of()));
  return(result);
}

BigRat 
operator- (const BigRat& a, const SmallInt& b) 
{
  BigRat result = BigRat(normalize(a.rational_of() - rational(b.i_value()))); 
  return(result);
}

BigRat 
operator* (const SmallInt& a, const BigRat& b) 
{
  BigRat result = BigRat(normalize(rational(a.i_value()) * b.rational_of()));
  return(result);
}

BigRat 
operator* (const BigRat& a, const SmallInt& b) 
{
  BigRat result = BigRat(normalize(rational(b.i_value()) * a.rational_of()));
  return(result);
}

BigRat 
operator/ (const SmallInt& a, const BigRat& b) 
{
  BigRat result = BigRat(normalize(rational(a.i_value()) / b.rational_of()));
  return(result);
}

BigRat 
operator/ (const BigRat& a, const SmallInt& b) 
{
  BigRat result = BigRat(normalize(rational(b.i_value()) / a.rational_of()));
  return(result);
}

