
/*************************************************************************

  APU R 2.0

  greaterthan.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(GREATERTHAN_HDR) 
#define GREATERTHAN_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class GreaterThan {
  public : 
    GreaterThan();
    GreaterThan(bool&, const Field_element&, const Field_element&); 
    GreaterThan(bool&, const SmallInt&, const SmallInt&); 
    GreaterThan(bool&, const BigInt&, const BigInt&); 
    GreaterThan(bool&, const Float&, const Float&); 
    GreaterThan(bool&, const BigFloat&, const BigFloat&); 
};

inline GreaterThan::GreaterThan() {
}

inline GreaterThan::GreaterThan(bool& c,const SmallInt& a,const SmallInt& b) {
  c = (a>b);
}

inline GreaterThan::GreaterThan(bool& c, const BigInt& a, const BigInt& b) {
  c = (a>b);
}

inline GreaterThan::GreaterThan(bool& c, const Float& a, const Float& b) {
  c = (a>b);
}

inline GreaterThan::GreaterThan(bool& c,const BigFloat& a,const BigFloat& b) {
  c = (a>b);
}

#endif
