
/*************************************************************************

  APU R 2.0

  minus.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(MINUS_HDR)

#define MINUS_HDR

#include "fielddef.h"
#include "fieldtypes.h"

class Minus {
  int type;
  public : 
    Minus();
    Minus(Field_element&, const Field_element&, const Field_element&);
    Minus(Field_element&, const SmallInt&, const SmallInt&);
    Minus(Field_element&, const IntModp&, const IntModp&);
    Minus(Field_element&, const IntModp&, const SmallInt&);
    Minus(Field_element&, const SmallInt&, const IntModp&);
    Minus(Field_element&, const BigInt&, const BigInt&);
    Minus(Field_element&, const SmallInt&, const BigInt&);
    Minus(Field_element&, const BigInt&, const SmallInt&);
    Minus(Field_element&, const Float&, const Float&);
    Minus(Field_element&, const SmallInt&, const Float&);
    Minus(Field_element&, const Float&, const SmallInt&);
    Minus(Field_element&, const BigFloat&, const BigFloat&);
    Minus(Field_element&, const Slp&, const Slp&);
    Minus(Field_element&, const SmallInt&, const Slp&);
    Minus(Field_element&, const Slp&, const SmallInt&);
    Minus(Field_element&, const BigInt&, const Slp&);
    Minus(Field_element&, const Slp&, const BigInt&);
};

inline Minus::Minus() {
}

inline Minus::Minus(Field_element& c, const SmallInt& a, const SmallInt& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const IntModp& a, const IntModp& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const IntModp& a, const SmallInt& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const SmallInt& a, const IntModp& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const BigInt& a, const BigInt& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const SmallInt& a, const BigInt& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const BigInt& a, const SmallInt& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const Float& a, const Float& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const SmallInt& a, const Float& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const Float& a, const SmallInt& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const BigFloat& a, const BigFloat& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const Slp& a, const Slp& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const SmallInt& a, const Slp& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const Slp& a, const SmallInt& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const BigInt& a, const Slp& b) {
  c = a-b;
}

inline Minus::Minus(Field_element& c, const Slp& a, const BigInt& b) {
  c = a-b;
}

#endif
