
/*************************************************************************

  APU R 2.0

  mod.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(MOD_HDR) 
#define MOD_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class Mod {
  public : 
    Mod();
    Mod(Field_element&, const Field_element&, const Field_element&); 
    Mod(Field_element&, const SmallInt&, const SmallInt&); 
    Mod(Field_element&, const IntModp&, const IntModp&); 
    Mod(Field_element&, const BigInt&, const BigInt&); 
    Mod(Field_element&, const Float&, const Float&); 
};

inline Mod::Mod() {
}

inline Mod::Mod(Field_element& c, const SmallInt& a, const SmallInt& b) {
  c = a%b;
}

inline Mod::Mod(Field_element& c, const IntModp& a, const IntModp& b) {
  c = a%b;
}

inline Mod::Mod(Field_element& c, const BigInt& a, const BigInt& b) {
  c = a%b;
}

inline Mod::Mod(Field_element& c, const Float& a, const Float& b) {
  c = a%b;
}

#endif
