
/*************************************************************************

  APU R 2.0

  notequals.h

  (c) 1996, Regents of the University of California. 
  All rights reserved. 

*************************************************************************/
  

#if !defined(NOTEQUALS_HDR) 
#define NOTEQUALS_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class NotEquals {
  public : 
    NotEquals();
    NotEquals(bool&, const Field_element&, const Field_element&); 
    NotEquals(bool&, const SmallInt&, const SmallInt&); 
    NotEquals(bool&, const IntModp&, const IntModp&); 
    NotEquals(bool&, const BigInt&, const BigInt&); 
    NotEquals(bool&, const Float&, const Float&); 
    NotEquals(bool&, const BigFloat&, const BigFloat&); 
};

inline NotEquals::NotEquals() {
}

inline NotEquals::NotEquals(bool& c, const SmallInt& a, const SmallInt& b) {
  c = (a!=b); 
}

inline NotEquals::NotEquals(bool& c, const IntModp& a, const IntModp& b) {
  c = (a!=b); 
}

inline NotEquals::NotEquals(bool& c, const BigInt& a, const BigInt& b) {
  c = (a!=b);
}

inline NotEquals::NotEquals(bool& c, const Float& a, const Float& b) {
  c = (a!=b);
}

inline NotEquals::NotEquals(bool& c, const BigFloat& a, const BigFloat& b) {
  c = (a!=b);
}

#endif
