
/*************************************************************************

  APU R 2.0

  field_relop.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(FIELDAUX2HDR)
#define FIELDAUX2HDR

#include "fielddef.h"
#include "binop.h"

template<class Type1, class RelOp> 
void
rel_op2 (bool& result,RelOp op, Type1 fe1, const Field_element& fe2) 
{ 
  switch(fe2.type_of()) {
    case SMALLINT : 
      RelOp(result,fe1,(SmallInt&)(fe2)); break;
    case INTMODP : 
      RelOp(result,fe1,(IntModp&)(fe2)); break;
    case BIGINT : 
      RelOp(result,fe1,(BigInt&)(fe2)); break;
    case FLOAT : 
      RelOp(result,fe1,(Float&)(fe2)); break;
    case BIGFLOAT : 
      RelOp(result,fe1,(BigFloat&)(fe2)); break;
    case RATFLOATF : 
      RelOp(result,fe1,(RatFloatf&)(fe2)); break;
    case SLP : 
      RelOp(result,fe1,(Slp&)(fe2)); break;
    default : break; // RelOp(result,fe1,fe2); break; 
  }
}

template<class RelOp>
void
rel_op (bool& result, RelOp op, 
	   const Field_element& fe1, const Field_element& fe2) 
{
  switch(fe1.type_of()){
    case SMALLINT : 
      rel_op2(result,op,(SmallInt&)(fe1),fe2); break;
    case INTMODP : 
      rel_op2(result,op,(IntModp&)(fe1),fe2); break;
    case BIGINT : 
      rel_op2(result,op,(BigInt&)(fe1),fe2); break;
    case FLOAT : 
      rel_op2(result,op,(Float&)(fe1),fe2); break;
    case BIGFLOAT : 
      rel_op2(result,op,(BigFloat&)(fe1),fe2); break;
    case RATFLOATF : 
      rel_op2(result,op,(RatFloatf&)(fe1),fe2); break;
    case SLP : 
      rel_op2(result,op,(Slp&)(fe1),fe2); break;
    default : break; // rel_op2(result,op,fe1,fe2); break;
  }
}

#endif
