
/*************************************************************************

  APU R 2.0

  equals.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(EQUALS_HDR) 
#define EQUALS_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class Equals {
  public : 
    Equals();
    Equals(bool&, const Field_element&, const Field_element&); 
    Equals(bool&, const SmallInt&, const SmallInt&); 
    Equals(bool&, const IntModp&, const IntModp&); 
    Equals(bool&, const MultiIntModp&, const MultiIntModp&); 
    Equals(bool&, const BigInt&, const BigInt&); 
    Equals(bool&, const Float&, const Float&); 
    Equals(bool&, const BigFloat&, const BigFloat&); 
};

inline Equals::Equals() {
}

inline Equals::Equals(bool& c, const SmallInt& a, const SmallInt& b) {
  c = (a==b); 
}

inline Equals::Equals(bool& c, const IntModp& a, const IntModp& b) {
  c = (a==b); 
}

inline Equals::Equals(bool& c, const MultiIntModp& a, const MultiIntModp& b) {
  c = (a==b); 
}

inline Equals::Equals(bool& c, const BigInt& a, const BigInt& b) {
  c = (a==b);
}

inline Equals::Equals(bool& c, const Float& a, const Float& b) {
  c = (a==b);
}

inline Equals::Equals(bool& c, const BigFloat& a, const BigFloat& b) {
  c = (a==b);
}

#endif
