
/*************************************************************************

  APU R 2.0

  det_sign.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(DET_SIGN_HDR) 
#define DET_SIGN_HDR 

#include "polynomial.h"
#include "array.h"
#include "matrix.h"

Polynomial 
compute_product(const Polynomial&,const List<Polynomial>&,Array<int>);

Array<int>
sturm_query_values(const Polynomial&,const List<Polynomial>&,Matrix<int>);

Matrix<int> det_sign(const Polynomial&, List<Polynomial>&);
Matrix<int> get_H1();
Matrix<int> r_hat_startup();
Matrix<int> s_hat_startup();
Matrix<int> augment_r_hat (Matrix<int>);
Matrix<int> compute_rows(Matrix<int>);
Matrix<int> compute_Hmatrix(Matrix<int>, Matrix<int>);
Matrix<int> eliminate_r_hat_zero_entries (Matrix<int>, Array<int>);
Array<int> eliminate_zero_entries (Array<int>);
Matrix<int> update_sturm_queries (Matrix<int>);
Array<int> rows (Array<int>);
Array<int> compute_L1(Array<int>);
Array<int> compute_L2(Array<int>);
Array<int> compute_L3(Array<int>);
int H_elt(int,int);
Array<int> make_trinary(int, int);
int make_decimal (Array<int>);
Array<int> reducemod(Array<int>,int);

#endif 
