
/*************************************************************************

  APU R 2.0

  mem_mgr.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(MEM_MGR_HDR) 
#define MEM_MGR_HDR

class Mem_mgr {
  private : 
    int ref_count; 
  public : 
    Mem_mgr(); 
    int ref_count_of() const { return ref_count; }
    void ref_count_inc() { ref_count++; }
    void ref_count_dec() { ref_count--; }
};

inline Mem_mgr::Mem_mgr() {
  ref_count = 1; 
}

inline int ref_count_of(const Mem_mgr& m) {
  return(m.ref_count_of()); 
}

inline void ref_count_inc(Mem_mgr m) {
  m.ref_count_inc(); 
}

inline void ref_count_dec(Mem_mgr m) {
  m.ref_count_dec(); 
}

#endif
