/*************************************************************************

  APU R 2.0

  polyaux.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

/* This file contains some convenient syntactic redefinitions of member
   functions which allow the use of "function(object)" syntax as
   opposed to the "object.function()" syntax for member functions. 

   It also contains definitions of some operators of the form
   "type2 op type1" code for which has effectively been written as
   "type1 op type2". 
*/

inline bool is_terminal(const Polynomial& a) {
  return(a.is_terminal()); 
}

inline Field_element fe_of(const Polynomial& a) {
  return(a.fe_of()); 
}

inline TermList termlist_of(const Polynomial& a) {
  return(a.termlist_of()); 
}

inline Variable* variable_of(const Polynomial& a) {
  return(a.variable_of()); 
}

inline int degree(const Polynomial& poly) {
  return(poly.degree());
}

inline Polynomial lcoeff(const Polynomial& poly) {
  return(poly.lcoeff());
}

inline bool is_zeropoly(const Polynomial& poly) { 
  return(poly.is_zeropoly());
}

inline Polynomial
operator + (const Field_element& fe, const Polynomial& poly) {
  return(poly + fe); 
}

inline TermList
operator + (const Field_element& fe, const TermList& tl) {
  return(tl + fe); 
}

inline TermList 
operator + (const Polynomial& poly, const TermList& tl) {
  return(tl + poly); 
}

inline TermList
operator * (const Field_element& fe, const TermList& tl) {
  return(tl * fe); 
}

inline TermList 
operator * (const Polynomial& poly, const TermList& tl) {
  return(tl * poly); 
}

inline Polynomial
operator * (const Field_element& fe, const Polynomial& poly) {
  return(poly * fe); 
}

inline 
Polynomial operator + (const Polynomial& poly, const int& ivalue) {
  Field_element fe = Field_element(ivalue); 
  return(poly + fe);
}

inline
Polynomial operator + (const int& ivalue, const Polynomial& poly) {
  Field_element fe = Field_element(ivalue); 
  return(fe + poly);
}

inline
Slp slp_of(const Polynomial& poly) { 
  if (fePtr_of(poly) != 0)
    return(*((Slp*)(fePtr_of(poly)))); 
  else cout << "Error in slp_of(Polynomial) - poly has null field element\n"; 
} 
