/*************************************************************************

  APU R 2.0

  edge.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/

#if !defined(EDGE_HDR)
#define EDGE_HDR

#include "globals.h"
#include "intpoint.h"

class Edge { 
  private : 
    int index; 
    IntPoint head; 
    IntPoint tail; 
  public : 
    Edge(); 
    Edge(IntPoint,IntPoint);
    IntPoint head_of(); 
    IntPoint tail_of(); 
    void set_index(int); 
    int get_index(); 
};

inline Edge::Edge() {} 

inline Edge::Edge(IntPoint hd, IntPoint tl) {
  head = hd; 
  tail = tl; 
}

inline IntPoint Edge::head_of() { 
  return head; 
} 

inline IntPoint head_of(Edge edge) { 
  return edge.head_of(); 
} 

inline IntPoint Edge::tail_of() { 
  return tail; 
} 

inline IntPoint tail_of(Edge edge) { 
  return edge.tail_of(); 
} 

inline void Edge::set_index(int indx) { 
  index = indx; 
}

inline int Edge::get_index() { 
  return index; 
}

inline int get_index(Edge edge) { 
  return edge.get_index(); 
}

typedef Array<Edge> EdgeArray; 
typedef Array<EdgeArray> EdgeMatrix;  

#endif
