
/*************************************************************************

  APU R 2.0

  mixvol.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#if !defined(MIXVOL_HDR) 
#define MIXVOL_HDR
#include "chull.h"
#include "polynomial.h"
#include "molynomial.h"

typedef Array<IntPoint> MonomArray; 

int mixvol(List<Polynomial>,bool=false);
int mixvol(List<Molynomial>,bool=false);
Array<MonomArray> monom_arrays(List<Molynomial>,int*,int**,int*,int*); 
double** make_simp_mat(int,int); 
Array<MonomArray> compute_chull_pts(Array<MonomArray>,double**); 
Array<MonomArray> lift_chull_pts(Array<MonomArray>); 
void lift_all(Array<MonomArray>); 
void lift(Array<IntPoint>); 
int mixvol(Array<Polynomial>,bool=false);
int mixvol(Array<Molynomial>,bool=false);
Array<MonomArray> monom_arrays(Array<Molynomial>,int**,int*,int*); 
int max_degree(MonomArray); 

#endif
