
/*************************************************************************

  APU R 2.0

  sparse_mat.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#if !defined(SPARSE_MAT_HDR) 
#define SPARSE_MAT_HDR
#include "sparse_res.h"
#include "file_io.h"
#include <stdio.h>
#include <ctype.h>
#include "matrix.h"
#include "slp.h"

Matrix<Slp> create_matrix(char*,char*,int,int,int,Array<SlpArray>,bool=false,
char* = ""); 
Array<MonomArray> get_inds(char*,int,int,int); 
Matrix<Slp> read_create_matrix(char*,int,int,int,Array<SlpArray>,
       Array<MonomArray>,bool=false,char* = "");

Matrix<Slp> metis_transform(Matrix<Slp>,char*); 
bool is_validindex(int,Array<int>,Array<MonomArray>); 
void skip_over_line(ifstream); 
void post_process(char*,char*,int,Matrix<int>); 
Matrix<Slp> elim_zero_rowcol(Matrix<Slp>); 
bool is_zerorow(Array<Slp>); 
bool is_zerocol(Matrix<Slp>,int); 
Array<int> get_order(Array<int>); 

#endif
