
/*************************************************************************

  APU R 2.0

  is_zero.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(IS_ZERO_HDR) 
#define IS_ZERO_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class Is_Zero {
  public : 
    Is_Zero();
    Is_Zero(bool&, const Field_element&); 
    Is_Zero(bool&, const SmallInt&); 
    Is_Zero(bool&, const IntModp&); 
    Is_Zero(bool&, const MultiIntModp&); 
    Is_Zero(bool&, const BigInt&); 
    Is_Zero(bool&, const Float&); 
    Is_Zero(bool&, const BigFloat&); 
    Is_Zero(bool&, const Slp&);
};

inline Is_Zero::Is_Zero() {
}

inline Is_Zero::Is_Zero(bool& c, const SmallInt& a) {
  c = is_zero(a);
}

inline Is_Zero::Is_Zero(bool& c, const IntModp& a) {
  c = is_zero(a);
}

inline Is_Zero::Is_Zero(bool& c, const MultiIntModp& a) {
  c = is_zero(a);
}

inline Is_Zero::Is_Zero(bool& c, const BigInt& a) {
  c = is_zero(a);
}

inline Is_Zero::Is_Zero(bool& c, const Float& a) {
  c = is_zero(a);
}

inline Is_Zero::Is_Zero(bool& c, const BigFloat& a) {
  c = is_zero(a);
}

inline Is_Zero::Is_Zero(bool& c, const Slp& a) {
  c = is_zero(a);
}


#endif
