
/*************************************************************************

  APU R 2.0

  poly_relop.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "polynomial.h"

bool
operator == (const Polynomial& a, const Polynomial& b) {

  bool result; 

  if (is_zeropoly(a)) {
    if (is_zeropoly(b)) result = true; else result = false;
  }
  else if (is_zeropoly(b)) result = false; 
  else if (is_terminal(a)) { 
    if (is_terminal(b))
      result = (fe_of(a) == fe_of(b)); 
    else {
      result = (fe_of(a) == termlist_of(b)); 
    }
  }
  else if (is_terminal(b)) {
    result = (termlist_of(a) == fe_of(b)); 
  }
  else if (variable_of(a)->index() == variable_of(b)->index()) {
    result = (termlist_of(a) == termlist_of(b)); 
  }
  else if (variable_of(a)->index() < variable_of(b)->index()) {
    result = (termlist_of(a) == b);  
  }
  else if (variable_of(a)->index() > variable_of(b)->index()) {
    result = (a == termlist_of(b)); 
  }
  return(result);
}

/* Note :  the operator == (fe,poly) is defined inline in the include file 
   as the following == operator with arguments switched */
bool
operator == (const Polynomial& poly, const Field_element& fe) {
  if (is_zeropoly(poly)) {
    if (is_zero(fe)) result = true; else result = false;
  }
  else if (is_zero(fe)) result = false; 
  if (is_terminal(poly)) { 
    return(fe_of(poly) == fe);
  }
  else return(termlist_of(poly) == fe);
}

