
/*************************************************************************

  APU R 2.0

  lift.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "edge.h"
#include "mixvol.h"
extern int Debug; 

void lift_all(Array<MonomArray> all_sites) { 
  for (int i=0;i<size_of(all_sites);i++) 
    lift(all_sites[i]); 
}

void lift(Array<IntPoint> given_pts) { 
  int num_pts = size_of(given_pts); 
  int dim = size_of(given_pts[0]); 

  IntPoint rv = random_point(dim); 
  for (int i=0;i<num_pts;i++) { 
    given_pts[i][dim-1] = dot_product(given_pts[i],rv,dim-1); 
  }
} 
